#ifndef UNICODE
#define UNICODE
#endif 

#include <windows.h>

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
HINSTANCE g_hInstance;

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE, PWSTR pCmdLine, int nCmdShow) {
  const wchar_t CLASS_NAME[] = TEXT("WindowClass");
  g_hInstance = hInstance;

  WNDCLASS wc = { };
  wc.lpfnWndProc = WindowProc;
  wc.hInstance = hInstance;
  wc.lpszClassName = CLASS_NAME;
  RegisterClass(&wc);

  HWND hwnd = CreateWindowEx(0, CLASS_NAME, L"o\tgEGA",
    WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, 400, 200,
    NULL, NULL, hInstance, NULL);

  if (hwnd == NULL) return 0;
  ShowWindow(hwnd, nCmdShow);

  MSG msg = { };
  while (GetMessage(&msg, NULL, 0, 0)) {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return 0;
}

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  static HWND hButton;

  switch (uMsg) {
  case WM_CREATE:
    hButton = CreateWindow(L"BUTTON", L"o\tgEGÁc", 
      WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 20, 20, 300, 30, 
      hwnd, NULL, g_hInstance, NULL);
    return 0;

  case WM_COMMAND:
    MessageBox(hwnd, L"24łI", L"o\tgEGA", MB_OK);
    return 0;

  case WM_DESTROY:
    PostQuitMessage(0);
    return 0;

  case WM_PAINT:
    PAINTSTRUCT ps;
    HDC hdc = BeginPaint(hwnd, &ps);
    FillRect(hdc, &ps.rcPaint, (HBRUSH)(COLOR_WINDOW+1));
    EndPaint(hwnd, &ps);
    return 0;
  }
  return DefWindowProc(hwnd, uMsg, wParam, lParam);
}
